
import java.io.*;
import java.sql.*;
import java.util.*;
import java.awt.*;

/*
 *
 * This class provides functions for accessing the database
 *
 */
public class DBConnect {

	// data and constants
	private static Connection con;
	private final static String MYSQL_DRIVER = "org.gjt.mm.mysql.Driver";
	private final static String MYSQL_URL = "jdbc:mysql://localhost/e_shoestore";



	public static Vector execSQLquery( String sqlExpr, String attr ) {

		Vector results = new Vector();
		try {

			con = openDB();

			Statement stmt = con.createStatement();
			ResultSet resultSet = stmt.executeQuery( sqlExpr );
			while( resultSet.next( ) ) {
				results.addElement( resultSet.getString( attr ) );
			}
			stmt.close();
			resultSet.close();

			closeDB( con );

		}
		// if an error occurs connecting to the db, print a message and exit
		catch( SQLException e ) {

		    e.printStackTrace( );
		    System.out.println( "<br><br>" );
		    System.out.println( "<br>SQLException: " + e.getMessage() );
		    System.out.println( "<br>SQLState:     " + e.getSQLState() );
		    System.out.println( "<br>ErrorCode:    " + e.getErrorCode() );
		    System.exit( 1 );

		}
		return( results );

	} // end execSQLquery


	public static String execSQLquery( String sqlExpr, int row ) {

		String result = new String( "" );
		try {

			con = openDB();

			Statement stmt = con.createStatement();
			ResultSet resultSet = stmt.executeQuery( sqlExpr );
			if( resultSet.next( ) ) {
				result = new String( resultSet.getString( row ) );
			}

			stmt.close();
			resultSet.close();

			closeDB( con );

		}
		// if an error occurs connecting to the db, print a message and exit
		catch( SQLException e ) {

		    e.printStackTrace( );
		    System.out.println( "<br><br>" );
		    System.out.println( "<br>SQLException: " + e.getMessage() );
		    System.out.println( "<br>SQLState:     " + e.getSQLState() );
		    System.out.println( "<br>ErrorCode:    " + e.getErrorCode() );
		    System.exit( 1 );

		}
		return( result );

	} // end execSQLquery


	// executes sql queries that have no output (e.g., insert, delete, etc.)
	public static void execSQLquery( String sqlExpr ) {

		try {

			con = openDB();

			Statement stmt = con.createStatement();
			stmt.executeUpdate( sqlExpr );
			stmt.close();

			closeDB( con );

		}
		// if an error occurs connecting to the db, print a message and exit
		catch( SQLException e ) {

		    e.printStackTrace( );
		    System.out.println( "<br><br>" );
		    System.out.println( "<br>SQLException: " + e.getMessage() );
		    System.out.println( "<br>SQLState:     " + e.getSQLState() );
		    System.out.println( "<br>ErrorCode:    " + e.getErrorCode() );
		    System.exit( 1 );

		}

	} // end execSQLquery


	private static Connection openDB( ) throws SQLException {

		// set up MySQL driver
		try {

			Class.forName( MYSQL_DRIVER ).newInstance();

		}
		// if an error occurs loading driver, print a message and exit
		catch( Exception e ) {

			System.err.println( "Unable to load driver." );
		    e.printStackTrace( );
		    System.exit( 1 );

		}
		return DriverManager.getConnection( MYSQL_URL, "", "" );
	}



	private static void closeDB( Connection con ) throws SQLException {

		con.close();

	}

} // end class DBConnect